libzypp: zypp::sat::detail::WhatProvidesIterator Class Reference

libzypp 17.36.6

Public Member Functions | Private Member Functions | Private Attributes | Friends | List of all members
zypp::sat::detail::WhatProvidesIterator Class Reference

WhatProvides iterator. More...

`#include <zypp/sat/WhatProvides.h>`

Inheritance diagram for zypp::sat::detail::WhatProvidesIterator:

## Public Member Functions
| WhatProvidesIterator ()
| WhatProvidesIterator (const detail::IdType *const base_r, unsigned offset_r=0)
| Ctor with pointer to 1st elemment of an array.
| WhatProvidesIterator (const detail::IdType *const *baseRef_r, unsigned offset_r)
| Ctor with pointer to pointer to 1st elemment of an array.
| WhatProvidesIterator (const WhatProvidesIterator &rhs)
| Copy-ctor required to keep _baseRef adjusted.
WhatProvidesIterator & | operator= (const WhatProvidesIterator &rhs)
| Assignment operator required to keep _baseRef adjusted.

## Private Member Functions
reference | dereference () const
bool | equal (const WhatProvidesIterator &rhs) const
void | increment ()
detail::IdType | getId () const

## Private Attributes
const detail::IdType *const * | _baseRef
unsigned | _offset

## Friends
class | boost::iterator_core_access
std::ostream & | operator<< (std::ostream &str, const WhatProvidesIterator &obj)

## Detailed Description

WhatProvides iterator.

Iterate a NULL terminated sat::detail::IdType array. Ctor gets the adress of a pointer to the array, and offset into the array. This is needed in case the array gets reallocated.

Definition at line 154 of file WhatProvides.h.

## Constructor & Destructor Documentation

## ◆ WhatProvidesIterator() [1/4]

zypp::sat::detail::WhatProvidesIterator::WhatProvidesIterator | ( |  | ) |
| inline

Definition at line 164 of file WhatProvides.h.

## ◆ WhatProvidesIterator() [2/4]

zypp::sat::detail::WhatProvidesIterator::WhatProvidesIterator | ( | const detail::IdType *const | base_r,
|  | unsigned | offset_r = 0 )
| inlineexplicit

Ctor with pointer to 1st elemment of an array.

Use otherwise unused base as pointer for _baseRef.

Definition at line 171 of file WhatProvides.h.

## ◆ WhatProvidesIterator() [3/4]

zypp::sat::detail::WhatProvidesIterator::WhatProvidesIterator | ( | const detail::IdType *const * | baseRef_r,
|  | unsigned | offset_r )
| inlineexplicit

Ctor with pointer to pointer to 1st elemment of an array.

Required for arrays that might be relocated while iterating.

Definition at line 178 of file WhatProvides.h.

## ◆ WhatProvidesIterator() [4/4]

zypp::sat::detail::WhatProvidesIterator::WhatProvidesIterator | ( | const WhatProvidesIterator & | rhs | ) |
| inline

Copy-ctor required to keep _baseRef adjusted.

Definition at line 183 of file WhatProvides.h.

## Member Function Documentation

## ◆ operator=()

WhatProvidesIterator & zypp::sat::detail::WhatProvidesIterator::operator= | ( | const WhatProvidesIterator & | rhs | ) |
| inline

Assignment operator required to keep _baseRef adjusted.

Definition at line 190 of file WhatProvides.h.

## ◆ dereference()

reference zypp::sat::detail::WhatProvidesIterator::dereference | ( |  | ) | const
| inlineprivate

Definition at line 204 of file WhatProvides.h.

## ◆ equal()

bool zypp::sat::detail::WhatProvidesIterator::equal | ( | const WhatProvidesIterator & | rhs | ) | const
| inlineprivate

Definition at line 210 of file WhatProvides.h.

## ◆ increment()

void zypp::sat::detail::WhatProvidesIterator::increment | ( |  | ) |
| inlineprivate

Definition at line 221 of file WhatProvides.h.

## ◆ getId()

detail::IdType zypp::sat::detail::WhatProvidesIterator::getId | ( |  | ) | const
| inlineprivate

Definition at line 224 of file WhatProvides.h.

## Friends And Related Symbol Documentation

## ◆ boost::iterator_core_access

friend class boost::iterator_core_access
| friend

Definition at line 202 of file WhatProvides.h.

## ◆ operator<<

std::ostream & operator<< | ( | std::ostream & | str,
|  | const WhatProvidesIterator & | obj )
| friend

Definition at line 171 of file WhatProvides.cc.

## Member Data Documentation

## ◆ _baseRef

const detail::IdType* const* zypp::sat::detail::WhatProvidesIterator::_baseRef
| private

Definition at line 228 of file WhatProvides.h.

## ◆ _offset

unsigned zypp::sat::detail::WhatProvidesIterator::_offset
| private

Definition at line 229 of file WhatProvides.h.

The documentation for this class was generated from the following file:

- zypp/sat/WhatProvides.h